searchNodes=[{"doc":"A tool which allows to define specs for runtime configuration, cast values according to specified types and inspect them.","ref":"Confispex.html","title":"Confispex","type":"module"},{"doc":"Returns true if all required variables in specified group are present in store.","ref":"Confispex.html#all_required_touched?/2","title":"Confispex.all_required_touched?/2","type":"function"},{"doc":"Returns true if any required variable in specified group is present in store. If variable is present, then it means you was trying to configure the group. This is needed for conditional configuration of applications that may shutdown the system if you try to configure the application with invalid params. Example if Confispex . any_required_touched? ( :apns ) do config :pigeon , :apns , sandbox : %{ cert : Confispex . get ( &quot;APNS_CERT&quot; ) , key : Confispex . get ( &quot;APNS_KEY&quot; ) , mode : :dev } end","ref":"Confispex.html#any_required_touched?/2","title":"Confispex.any_required_touched?/2","type":"function"},{"doc":"Get a value from store by specified variable name (key) and cast it according to schema. Example config :my_app , MyApp.Repo , url : Confispex . get ( &quot;DATABASE_URL&quot; ) In case of any error during casting nil is returned, errors are saved and can be retrieved later using report/1 function.","ref":"Confispex.html#get/2","title":"Confispex.get/2","type":"function"},{"doc":"Initialize or reinitialize a state in server Example Confispex . init ( %{ schema : MyApp.RuntimeConfigSchema , context : %{ env : config_env ( ) , target : config_target ( ) } } ) By default, Confispex uses System.get_env/0 to setup the store.","ref":"Confispex.html#init/2","title":"Confispex.init/2","type":"function"},{"doc":"Initialize a state in server if it hasn't already been initialized Example Confispex . init ( %{ schema : MyApp.RuntimeConfigSchema , context : %{ env : config_env ( ) , target : config_target ( ) } } ) By default, Confispex uses System.get_env/0 to setup the store.","ref":"Confispex.html#init_once/2","title":"Confispex.init_once/2","type":"function"},{"doc":"Print report with variables usage to STDOUT. The difference between :detailed and :brief modes is that :brief doesn't print values of the store. Use :brief if you don't want to show sensitive data. Example Confispex . report ( :detailed )","ref":"Confispex.html#report/2","title":"Confispex.report/2","type":"function"},{"doc":"Update a store Example new_store = %{ ... } Confispex . update_store ( &amp; Map . merge ( &amp;1 , new_store ) )","ref":"Confispex.html#update_store/2","title":"Confispex.update_store/2","type":"function"},{"doc":"","ref":"Confispex.html#t:context/0","title":"Confispex.context/0","type":"type"},{"doc":"","ref":"Confispex.html#t:store/0","title":"Confispex.store/0","type":"type"},{"doc":"Example defmodule MyApp.RuntimeConfigSchema do import Confispex.Schema @behaviour Confispex.Schema alias Confispex.Type defvariables ( %{ &quot;RUNTIME_CONFIG_REPORT&quot; =&gt; %{ cast : { Type.Enum , values : [ &quot;disabled&quot; , &quot;detailed&quot; , &quot;brief&quot; ] } , default : &quot;disabled&quot; , groups : [ :misc ] } , &quot;TZDATA_AUTOUPDATE_ENABLED&quot; =&gt; %{ doc : &quot;Autoupdate timezones from IANA Time Zone Database&quot; , cast : Type.Boolean , default : &quot;false&quot; , groups : [ :base ] , context : [ env : [ :dev , :prod ] ] } , &quot;LOG_LEVEL&quot; =&gt; %{ cast : { Type.Enum , values : [ &quot;emergency&quot; , &quot;alert&quot; , &quot;critical&quot; , &quot;error&quot; , &quot;warning&quot; , &quot;notice&quot; , &quot;info&quot; , &quot;debug&quot; , &quot;none&quot; ] } , default_lazy : fn %{ env : :test } -&gt; &quot;warning&quot; %{ env : :dev } -&gt; &quot;debug&quot; %{ env : :prod } -&gt; &quot;debug&quot; end , groups : [ :base ] } , &quot;DATABASE_URL&quot; =&gt; %{ aliases : [ &quot;DB_URL&quot; ] , doc : &quot;Full DB URL&quot; , cast : Type.URL , context : [ env : [ :prod ] ] , groups : [ :primary_db ] , required : [ :primary_db ] } , &quot;DATABASE_POOL_SIZE&quot; =&gt; %{ aliases : [ &quot;DB_POOL_SIZE&quot; , &quot;POOL_SIZE&quot; ] , cast : { Type.Integer , scope : :positive } , default : &quot;10&quot; , context : [ env : [ :prod ] ] , groups : [ :primary_db ] } } ) end","ref":"Confispex.Schema.html","title":"Confispex.Schema","type":"behaviour"},{"doc":"A helper which performs basic validations of the input schema and then defines variables_schema/0 function.","ref":"Confispex.Schema.html#defvariables/1","title":"Confispex.Schema.defvariables/1","type":"macro"},{"doc":"","ref":"Confispex.Schema.html#c:variables_schema/0","title":"Confispex.Schema.variables_schema/0","type":"callback"},{"doc":"","ref":"Confispex.Schema.html#t:variable_name/0","title":"Confispex.Schema.variable_name/0","type":"type"},{"doc":"A spec for a single variable :cast - describes how value should be cast. :groups - a list of groups which are affected by variable. :doc - a description about variable, shown in generated .envrc file. :default - default value. Must be set in raw format. Raw format was choosen to populate .envrc file with default values. :defaut_lazy - default value based on given context. Useful when default value must be different for different environments. Cannot be used alongside with :default parameter. Return nil if default value should be ignored. :template_value_generator - a function that is used in confispex.gen.envrc_template mix task to generate a value for a variable. Such value will always be uncommented even if it is not required. This is useful for variables like &quot;SECRET_KEY_BASE&quot; which should be generated only once. :required - a list of groups or a function that returns a list of groups in which variable is required. When all required variables of the group are cast successfully, then the group is considered as ready for using. :context - specifies context in which variable is used. :aliases - a list of alias names.","ref":"Confispex.Schema.html#t:variable_spec/0","title":"Confispex.Schema.variable_spec/0","type":"type"},{"doc":"","ref":"Confispex.Type.html","title":"Confispex.Type","type":"behaviour"},{"doc":"Cast input using type in type_reference() Examples iex&gt; Confispex.Type . cast ( &quot;dev&quot; , { Confispex.Type.Enum , values : [ :prod , :test , :dev ] } ) { :ok , &quot;dev&quot; } iex&gt; Confispex.Type . cast ( &quot;prodd&quot; , { Confispex.Type.Enum , values : [ :prod , :test , :dev ] } ) { :error , { &quot;prodd&quot; , { Confispex.Type.Enum , [ values : [ :prod , :test , :dev ] ] } , [ validation : [ &quot;expected one of: &quot; , [ { :highlight , &quot;prod&quot; } , &quot;, &quot; , { :highlight , &quot;test&quot; } , &quot;, &quot; , { :highlight , &quot;dev&quot; } ] ] ] } }","ref":"Confispex.Type.html#cast/2","title":"Confispex.Type.cast/2","type":"function"},{"doc":"","ref":"Confispex.Type.html#c:cast/2","title":"Confispex.Type.cast/2","type":"callback"},{"doc":"","ref":"Confispex.Type.html#t:error_details/0","title":"Confispex.Type.error_details/0","type":"type"},{"doc":"","ref":"Confispex.Type.html#t:type_reference/0","title":"Confispex.Type.type_reference/0","type":"type"},{"doc":"Generate a doc in markdown format Examples $ mix confispex.gen.doc.md --output=RUNTIME_ENV_PROD.md --schema=MyRuntimeConfigSchema --env=prod --target=abc Example of generated markdown # Variables (env=dev target=host) ## GROUP :dev_space | Name | Required | Default | Description | | -- -- -- -- -- -- -- -- -- | -- -- -- -- | -- -- -- - | -- -- -- -- -- -- -- -- -- -- -- -- - | | DEV_SPACE_PASSWORD | required | | A password for / dev space | | DEV_SPACE_USERNAME | required | | A username for / dev space | ## GROUP :primary_db | Name | Required | Default | Description | | -- -- -- -- -- -- -- -- -- | -- -- -- -- | -- -- -- -- - | -- -- -- -- -- -- -- -- -- -- -- | | DATABASE_HOST | | localhost | DB host ( postgres ) | | DATABASE_NAME | | myapp_dev | DB name ( postgres ) | | DATABASE_PASSWORD | | postgres | DB password ( postgres ) | | DATABASE_POOL_SIZE | | 10 | | | DATABASE_PORT | | 5432 | DB port ( postgres ) | | DATABASE_USERNAME | | postgres | DB username ( postgres ) | Integration with ex_doc Adjust your mix.exs file with the following content defmodule MyApp.MixProject do use Mix.Project def project do [ # ... aliases : aliases ( ) , docs : [ extras : [ &quot;tmp/runtime_env_prod.md&quot; : [ title : &quot;prod&quot; ] , &quot;tmp/runtime_env_dev.md&quot; : [ title : &quot;dev&quot; ] , &quot;tmp/runtime_env_test.md&quot; : [ title : &quot;test&quot; ] ] , groups_for_extras : [ &quot;Runtime ENV&quot; : ~r|tmp/runtime_env_.+ \\. md| ] ] ] end defp aliases do [ # ... docs : [ fn _ -&gt; File . mkdir_p! ( &quot;tmp&quot; ) end | Enum . map ( [ &quot;test&quot; , &quot;prod&quot; , &quot;dev&quot; ] , fn env -&gt; fn _ -&gt; Mix.Task . rerun ( &quot;confispex.gen.doc.md&quot; , [ &quot;--output&quot; , &quot;tmp/runtime_env_ \#{ env } .md&quot; , &quot;--schema&quot; , &quot;MyApp.RuntimeConfigSchema&quot; , # &lt;--- Change module name &quot;--env&quot; , env ] ) end end ) ++ [ &quot;docs&quot; ] ] ] end end","ref":"Mix.Tasks.Confispex.Gen.Doc.Md.html","title":"Mix.Tasks.Confispex.Gen.Doc.Md","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Confispex.Gen.Doc.Md.html#run/1","title":"Mix.Tasks.Confispex.Gen.Doc.Md.run/1","type":"function"},{"doc":"Generate .envrc template for dotenv utility Examples $ mix confispex.gen.template.envrc --output=.envrc --schema=MyRuntimeConfigSchema","ref":"Mix.Tasks.Confispex.Gen.Template.Envrc.html","title":"Mix.Tasks.Confispex.Gen.Template.Envrc","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Confispex.Gen.Template.Envrc.html#run/1","title":"Mix.Tasks.Confispex.Gen.Template.Envrc.run/1","type":"function"},{"doc":"A type for base64 encoded values. Decodes base64 encoded string. Options :of - Confispex.Type.String is used by default. Other types can be used as well according to Confispex.Type.type_reference/0 Examples iex&gt; Confispex.Type . cast ( &quot;aGVsbG8=&quot; , Confispex.Type.Base64Encoded ) { :ok , &quot;hello&quot; } iex&gt; Confispex.Type . cast ( &quot;//8=&quot; , Confispex.Type.Base64Encoded ) { :error , { &lt;&lt; 255 , 255 &gt;&gt; , Confispex.Type.String , [ validation : &quot;not a valid string&quot; ] } } iex&gt; Confispex.Type . cast ( &quot;//8=&quot; , { Confispex.Type.Base64Encoded , of : Confispex.Type.Term } ) { :ok , &lt;&lt; 0xFFFF :: 16 &gt;&gt; }","ref":"Confispex.Type.Base64Encoded.html","title":"Confispex.Type.Base64Encoded","type":"module"},{"doc":"A boolean type. Casts &quot;enabled&quot; , &quot;true&quot; , &quot;1&quot; , &quot;yes&quot; , 1 , true to true , and &quot;disabled&quot; , &quot;false&quot; , &quot;0&quot; , &quot;no&quot; , 0 , false to false . No options. Examples iex&gt; Confispex.Type . cast ( &quot;yes&quot; , Confispex.Type.Boolean ) { :ok , true } iex&gt; Confispex.Type . cast ( &quot;true&quot; , Confispex.Type.Boolean ) { :ok , true } iex&gt; Confispex.Type . cast ( &quot;0&quot; , Confispex.Type.Boolean ) { :ok , false } iex&gt; Confispex.Type . cast ( &quot;disabled&quot; , Confispex.Type.Boolean ) { :ok , false } iex&gt; Confispex.Type . cast ( &quot;DISABLED&quot; , Confispex.Type.Boolean ) { :error , { &quot;DISABLED&quot; , Confispex.Type.Boolean , [ validation : [ &quot;expected one of: &quot; , [ { :highlight , &quot;enabled&quot; } , &quot;, &quot; , { :highlight , &quot;true&quot; } , &quot;, &quot; , { :highlight , &quot;1&quot; } , &quot;, &quot; , { :highlight , &quot;yes&quot; } , &quot;, &quot; , { :highlight , &quot;disabled&quot; } , &quot;, &quot; , { :highlight , &quot;false&quot; } , &quot;, &quot; , { :highlight , &quot;0&quot; } , &quot;, &quot; , { :highlight , &quot;no&quot; } ] ] ] } }","ref":"Confispex.Type.Boolean.html","title":"Confispex.Type.Boolean","type":"module"},{"doc":"A CSV type. Casts a CSV string to a list with values which are cast according to :of option. Options :of - Confispex.Type.String is used by default. Can be used any other type according to Confispex.Type.type_reference/0 Examples iex&gt; Confispex.Type . cast ( &quot;John,user1@example.com&quot; , Confispex.Type.CSV ) { :ok , [ &quot;John&quot; , &quot;user1@example.com&quot; ] } iex&gt; Confispex.Type . cast ( &quot;John,user1@example.com&quot; , { Confispex.Type.CSV , of : Confispex.Type.Email } ) { :error , { &quot;John,user1@example.com&quot; , { Confispex.Type.CSV , [ of : Confispex.Type.Email ] } , [ nested : [ { &quot;John&quot; , Confispex.Type.Email , [ parsing : [ &quot;expected a string in format &quot; , { :highlight , &quot;username@host&quot; } ] ] } ] ] } } iex&gt; Confispex.Type . cast ( ~s|John,&quot;user1@example.com| , Confispex.Type.CSV ) { :error , { ~s|John,&quot;user1@example.com| , Confispex.Type.CSV , [ parsing : ~s|expected escape character &quot; but reached the end of file| ] } }","ref":"Confispex.Type.CSV.html","title":"Confispex.Type.CSV","type":"module"},{"doc":"An email type. Returns input value if it is in username@host format. No options. Examples iex&gt; Confispex.Type . cast ( &quot;user@example.com&quot; , Confispex.Type.Email ) { :ok , &quot;user@example.com&quot; } iex&gt; Confispex.Type . cast ( &quot;user[at]example.com&quot; , Confispex.Type.Email ) { :error , { &quot;user[at]example.com&quot; , Confispex.Type.Email , [ parsing : [ &quot;expected a string in format &quot; , { :highlight , &quot;username@host&quot; } ] ] } }","ref":"Confispex.Type.Email.html","title":"Confispex.Type.Email","type":"module"},{"doc":"An enum type. Returns input value if it is present in a list specified in :values option. Options :values - required option, can be a list of any values which implement String.Chars protocol. Examples iex&gt; Confispex.Type . cast ( &quot;low&quot; , { Confispex.Type.Enum , values : [ &quot;low&quot; , &quot;high&quot; ] } ) { :ok , &quot;low&quot; } iex&gt; Confispex.Type . cast ( &quot;LOW&quot; , { Confispex.Type.Enum , values : [ &quot;low&quot; , &quot;high&quot; ] } ) { :error , { &quot;LOW&quot; , { Confispex.Type.Enum , [ values : [ &quot;low&quot; , &quot;high&quot; ] ] } , [ validation : [ &quot;expected one of: &quot; , [ { :highlight , &quot;low&quot; } , &quot;, &quot; , { :highlight , &quot;high&quot; } ] ] ] } }","ref":"Confispex.Type.Enum.html","title":"Confispex.Type.Enum","type":"module"},{"doc":"A float type. Casts input string to Float . No options. Examples iex&gt; Confispex.Type . cast ( &quot;3.14&quot; , Confispex.Type.Float ) { :ok , 3.14 } iex&gt; Confispex.Type . cast ( &quot;314&quot; , Confispex.Type.Float ) { :ok , 314.0 } iex&gt; Confispex.Type . cast ( &quot;1.0e2&quot; , Confispex.Type.Float ) { :ok , 100.0 } iex&gt; Confispex.Type . cast ( &quot;1.0ee2&quot; , Confispex.Type.Float ) { :error , { &quot;1.0ee2&quot; , Confispex.Type.Float , [ parsing : [ &quot;unexpected substring &quot; , { :highlight , ~s|&quot;ee2&quot;| } ] ] } }","ref":"Confispex.Type.Float.html","title":"Confispex.Type.Float","type":"module"},{"doc":"An integer type. Casts input string to Integer . Options :scope - can be :positive , requires parsed integer value to be &gt; 0 Examples iex&gt; Confispex.Type . cast ( &quot;-42&quot; , Confispex.Type.Integer ) { :ok , - 42 } iex&gt; Confispex.Type . cast ( &quot;-42&quot; , { Confispex.Type.Integer , scope : :positive } ) { :error , { &quot;-42&quot; , { Confispex.Type.Integer , [ scope : :positive ] } , [ validation : &quot;expected a positive integer&quot; ] } } iex&gt; Confispex.Type . cast ( &quot;42 monkeys&quot; , Confispex.Type.Integer ) { :error , { &quot;42 monkeys&quot; , Confispex.Type.Integer , [ parsing : [ &quot;unexpected substring &quot; , { :highlight , ~s|&quot; monkeys&quot;| } ] ] } }","ref":"Confispex.Type.Integer.html","title":"Confispex.Type.Integer","type":"module"},{"doc":"A JSON type. Casts JSON string to Elixir terms using Jason library. Options :keys - possible values are: :strings (default), :atoms , :atoms! . Read about meaning of this values in doc for Jason.decode/2 . Examples iex&gt; Confispex.Type . cast ( ~s|[{&quot;email&quot;:&quot;john@example.com&quot;,&quot;level&quot;:1}]| , Confispex.Type.JSON ) { :ok , [ %{ &quot;email&quot; =&gt; &quot;john@example.com&quot; , &quot;level&quot; =&gt; 1 } ] } iex&gt; Confispex.Type . cast ( ~s|[{&quot;email&quot;:&quot;john@example.com&quot;,&quot;level&quot;:1}]| , { Confispex.Type.JSON , keys : :atoms } ) { :ok , [ %{ email : &quot;john@example.com&quot; , level : 1 } ] } iex&gt; Confispex.Type . cast ( &quot;&quot; , Confispex.Type.JSON ) { :error , { &quot;&quot; , Confispex.Type.JSON , [ parsing : &quot;unexpected end of input at position 0&quot; ] } }","ref":"Confispex.Type.JSON.html","title":"Confispex.Type.JSON","type":"module"},{"doc":"A string type. Returns input string if it is not empty. No options. Examples iex&gt; Confispex.Type . cast ( &quot;value&quot; , Confispex.Type.String ) { :ok , &quot;value&quot; } iex&gt; Confispex.Type . cast ( &quot;&quot; , Confispex.Type.String ) { :error , { &quot;&quot; , Confispex.Type.String , [ validation : &quot;blank string&quot; ] } } iex&gt; Confispex.Type . cast ( &quot;value&quot; &lt;&gt; &lt;&lt; 0xFFFF :: 16 &gt;&gt; , Confispex.Type.String ) { :error , { &quot;value&quot; &lt;&gt; &lt;&lt; 0xFFFF :: 16 &gt;&gt; , Confispex.Type.String , [ validation : &quot;not a valid string&quot; ] } }","ref":"Confispex.Type.String.html","title":"Confispex.Type.String","type":"module"},{"doc":"Represents any term. Returns input. No options. Examples iex&gt; Confispex.Type . cast ( &quot;value&quot; , Confispex.Type.Term ) { :ok , &quot;value&quot; } iex&gt; Confispex.Type . cast ( &quot;&quot; , Confispex.Type.Term ) { :ok , &quot;&quot; }","ref":"Confispex.Type.Term.html","title":"Confispex.Type.Term","type":"module"},{"doc":"An URL type. Returns input string if it is a valid URL. No options. Examples iex&gt; Confispex.Type . cast ( &quot;postgres://user@pass:host&quot; , Confispex.Type.URL ) { :ok , &quot;postgres://user@pass:host&quot; } iex&gt; Confispex.Type . cast ( &quot;localhost&quot; , Confispex.Type.URL ) { :error , { &quot;localhost&quot; , Confispex.Type.URL , [ validation : &quot;missing a scheme (e.g. https)&quot; ] } }","ref":"Confispex.Type.URL.html","title":"Confispex.Type.URL","type":"module"},{"doc":"Getting started The package can be installed by adding confispex to your list of dependencies in mix.exs : def deps do [ { :confispex , &quot;~&gt; 1.0&quot; } ] end Let's define the first version of a variables schema and runtime config with confispex : defmodule MyApp.RuntimeConfigSchema do import Confispex.Schema @behaviour Confispex.Schema alias Confispex.Type defvariables ( %{ &quot;RUNTIME_CONFIG_REPORT&quot; =&gt; %{ cast : { Type.Enum , values : [ &quot;disabled&quot; , &quot;detailed&quot; , &quot;brief&quot; ] } , default : &quot;disabled&quot; , groups : [ :misc ] } , &quot;DATABASE_URL&quot; =&gt; %{ aliases : [ &quot;DB_URL&quot; ] , doc : &quot;Full DB URL&quot; , cast : Type.URL , context : [ env : [ :prod ] ] , groups : [ :primary_db ] , required : [ :primary_db ] } , &quot;DATABASE_POOL_SIZE&quot; =&gt; %{ aliases : [ &quot;DB_POOL_SIZE&quot; , &quot;POOL_SIZE&quot; ] , cast : { Type.Integer , scope : :positive } , default : &quot;10&quot; , context : [ env : [ :prod ] ] , groups : [ :primary_db ] } , &quot;CONTACT_US_EMAILS&quot; =&gt; %{ cast : { Type.CSV , of : Type.Email } , default : &quot;help@example.com,feedback@example.com&quot; , groups : [ :landing_page ] , context : [ env : [ :dev , :prod ] ] } } ) end You can read about all possible options in doc about the type Confispex.Schema.variable_spec/0 . Put the following content to config/runtime.exs : import Config Confispex . init ( %{ schema : MyApp.RuntimeConfigSchema , context : %{ env : config_env ( ) , target : config_target ( ) } } ) # application config config :my_app , contact_us_emails : Confispex . get ( &quot;CONTACT_US_EMAILS&quot; ) , database_pool : Confispex . get ( &quot;DATABASE_POOL_SIZE&quot; ) , database_ssl : ! Confispex . get ( &quot;DATABASE_NO_SSL&quot; ) # printing report should be at the end case Confispex . get ( &quot;RUNTIME_CONFIG_REPORT&quot; ) do &quot;disabled&quot; -&gt; :noop &quot;detailed&quot; -&gt; Confispex . report ( :detailed ) &quot;brief&quot; -&gt; Confispex . report ( :brief ) end Now, if you run RUNTIME_CONFIG_REPORT = detailed CONTACT_US_EMAILS = myemail1 @example . com , myemail2 MIX_ENV = prod mix run -- no - halt you'll see the following report Group colors green - group has required variables and they are present and valid. Such color is not present on a screenshot above, we'll make green group later. red - group has requried variables, they aren't present or they are invalid. blue - group doesn't have required variables and always functional, because there is always a default value to which system can fall back. There are 3 groups in our example :landing_page , :misc and :primary_db : :primary_db is not functional, because all required variables weren't provided. :misc is functional, everything is valid. :landing_page is functional too, because even if system failed to cast some value, default value is present and it is used. Symbols * variable is required in specified group. ? variable is defined in schema, but was not invoked in runtime.exs . It is not an error, just a warning. It might be a desired behavour for your case to have such items, because they may be hidden by some conditions which depend on other variables. ✓ variable was provided and it is valid according to schema. - variable not provided, but default value is present and used. There is a block MISSING SCHEMA DEFINITIONS at the bottom. It simply prints variable names which were invoked in runtime.exs , but not present in the schema. Let's make everything functional. Add DATABASE_NO_SSL to the schema: &quot;DATABASE_NO_SSL&quot; =&gt; %{ aliases : [ &quot;DB_NO_SSL&quot; ] , cast : Type.Boolean , default : &quot;false&quot; , context : [ env : [ :prod ] ] , groups : [ :primary_db ] } Set DATABASE_URL in runtime.exs : config :my_app , # ... database_url : Confispex . get ( &quot;DATABASE_URL&quot; ) , and run report with valid values: RUNTIME_CONFIG_REPORT = detailed CONTACT_US_EMAILS = myemail1 @example . com , myemail2 @host DB_URL = postgres :/ / user :pwd@localhost : 5432 / db_name MIX_ENV = prod mix run -- no - halt","ref":"getting_started.html","title":"Getting Started","type":"extras"}]